/*
 * hex.h
 *
 *  Created on: 23 Nov 2019
 *      Author: jwalto
 */

#ifndef SRC_LIB_HEX_H_
#define SRC_LIB_HEX_H_

#include <cstdlib>
#include <vector>

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

class Hex {
	public:
		Hex(int q, int r, int s);
		Hex(int q, int r);

		int q() const;
		int r() const;
		int s() const;

		bool operator==(const Hex& hex) const;

		Hex operator+(const Hex& hex) const;
		Hex operator-(const Hex& hex) const;
		Hex operator*(const int factor) const;

		Hex rotate_left() const;
		Hex rotate_right() const;
		int length() const;

	private:
		const int q_;
		const int r_;
};

namespace std {
    template <> struct hash<Hex> {
        size_t operator()(const Hex& h) const;
    };
}

#endif /* SRC_LIB_HEX_H_ */
